.Dd 2016-06-01
.Dt CLUSTER-ALGEBRA-VISUALIZE 1
.Os
.Sh NAME
.Nm cluster-algebra-visualize
.Nd displays, and allows mutation of, cluster algebras in an ncurses display
.Sh SYNOPSIS
.Nm
.Oo
.Ar input-file
.Oc
.Sh DESCRIPTION
A
.Em cluster algebra
is a collection of
.Em quivers
which may be
.Em mutated
into one another. A
.Em quiver
may be visualized as a collection of vertices and arrows between the
vertices. The arrows have direction and multiplicity, and there cannot
be two different arrows between the same two vertices
.Pq even if the arrows are reversed .
.Pp
Cluster algebras come with an operation called
.Em mutation .
To mutate a quiver at a particular vertex
.Ar v ,
consider every
.Pq distinct
pair of vertices
.Ar t
and
.Ar u
which both have arrows
.Po call them, say,
.Ar e
and
.Ar f
respectively
.Pc
between them and
.Ar v .
If
.Ar e
points towards
.Ar v
and
.Ar f
points away from
.Ar v ,
then add a new arrow from
.Ar t
to
.Ar u
with multiplicity as the product of the multiplicities of
.Ar e
and
.Ar f
.Pq if an arrow is already present, just add to its multiplicity .
Once this has been done for all possible pairs (
.Ar t ,
.Ar u
), reverse the multiplicity
.Pq reverse the direction
of all arrows touching
.Ar v .
.Pp
This operation is rather tedious when the arrows become numerous, so
.Nm
does it for you.
.Sh CREATING
To begin, run
.Nm ,
which will show a blank screen.  Press
.Ql p
to create a new point: move by using h/j/k/l or the arrow keys, pressing
.Ql Enter
to select that position. If you wish to create a shape which is larger
than the display allows, use h/j/k/l to scroll the viewport. Add
arrows between points by pressing
.Ql a
and entering the numbers of points. Pressing
.Ql s
and providing a filename will save the current state to that file, and
running
.Nm
later with that filename as the
.Ar input-name
argument will load the state where you left off.
.Sh MUTATING
Perform mutation by pressing
.Ql m
and entering a list of
.Pq whitespace-separated
point-names. Mutation will be performed at each of the points in
order. For example, running
.Pp
.D1 % cluster-algebra-visualize /usr/share/cluster-algebra-visualize/7_a.txt
.Pp
should
.Pq depending on where your installation has put various files
display the quiver given by Fock and Goncharov when considering the
representation of a hyperbolic 3-simplex into SL(7, C). Performing the
following sequence of mutations:
.Pp
.D1 m 10 4 0 2 a 1a
.D1 m 11 5 1 9 19 23 f 3 b 1b
.D1 m 12 6 8 18 4 0 2 a 22 e c 1c
.D1 m 13 7 17 5 1 9 f 3 b 21 d 1d
.D1 m 14 16 6 8 0 2 e c 20 1e
.D1 m 15 7 1 3 d 1f
.Pp
will transform the quiver into the one given by running
.Pp
.D1 % cluster-algebra-visualize /usr/share/cluster-algebra-visualize/7_b.txt
.Pp
.Sh REFERENCES
.Pp
.Rs
.%A Robert Marsh
.%B Lecture Notes on Cluster Algebras
.%D 2013
.%C Zürich
.Re
.Pp
.Rs
.%A Vladimir Fock
.%A Alexander Goncharov
.%D 2006
.%T Moduli Spaces of Local Systems and Higher Teichmüller Theory
.%J Publications Mathématiques de l’Institut des Hautes Études Scientifiques 103
.%V 1
.%P 1–211
.%O DOI 10.1007/s10240-006-0039-4. Preprint at http://arxiv.org/abs/math/0311149v4
.Re
.Sh BUGS
.Bl -item
.It
No good error handling
.It
The display is a haphazard mixture of Unicode and ASCII. The author
would have preferred to use Unicode's drawing characters completely,
but found too many spacing errors in popular fonts to proceed.
.It
Arrows with multiplicities greater than 1 are simply drawn in reverse
color.  It is not easy to see what their multiplicity actually is,
other than saving the quiver state and counting the number of times
the arrow appears in the output.
.It
Arrows which overlap other arrows are not necessarily drawn
intelligently. If vertices are placed close together, the quiver may
be hard to read.
.It
To delete an arrow, add an arrow going the other way.
